Debian Bug report logs - #611650
tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)

version graph

Package: tcl8.5-dev; Maintainer for tcl8.5-dev is Debian Tcl/Tk Packagers <pkg-tcltk-devel@lists.alioth.debian.org>; Source for tcl8.5-dev is src:tcl8.5.

Reported by: Wookey <wookey@wookware.org>

Date: Mon, 31 Jan 2011 17:09:01 UTC

Severity: important

Found in version tcl8.5/8.5.8-2

Fixed in version tcl8.5/8.5.9-2

Done: Sergei Golovan <sgolovan@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#611650; Package tcl8.5-dev. (Mon, 31 Jan 2011 17:09:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
New Bug report received and forwarded. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Mon, 31 Jan 2011 17:09:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: submit@bugs.debian.org
Subject: tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)
Date: Mon, 31 Jan 2011 17:08:14 +0000
Subject: tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)
Package: tcl8.5-dev
Version: 8.5.8-2
Severity: important

*** Please type your report below this line ***
tcl8.5-dev contains /usr/lib/tcl8.5/tclConfig.sh
which is a symlink pointing to /usr/share/tcltk/tcl8.5/tclConfig.sh

Line 22 of that file is TCL_CC='x86_64-linux-gnu-gcc' on the x86_64
version and TCL_CC='arm-linux-gnueabi-gcc' on the armel version.
Also the TCL_DEFS= varies with arch, e.g 64-bit arches have different
defines from 32-bit arches.
So in fact it's not an arch-independent file, and shouldn't be in
/usr/share.

It is used during cross-compilation by other packages which make tcl
extensions. However, dpkg-cross (which deals with getting files into
the right place fpor cross-building in pre-multiarch setups) will
correctly not copy across links which point to files outside
(/usr)/lib, because arch-independent files should not be being
looked-for in /lib. This means that the link is simply missing when
other packages (e.g sqlite) try to build against tcl8.5.

I notice that upstream tcl builds these files in /lib but then we move
them into /usr/share and then put a link back in the old place. Is
there a good reason for this, or should we just leave them in /lib in
the first place?

i.e replace the existing:
--------------
in debian/rules:
install-stamp: build-stamp
     mv debian/tmp/usr/lib/*.sh debian/tmp/usr/share/tcltk/tcl$(v)

then later:
binary-arch: build install
     mv debian/tcl$(v)/usr/share/tcltk/tcl$(v)/tclConfig.sh \
        debian/tcl$(v)-dev/usr/lib/tcl$(v)
--------------
with:
install-stamp: build-stamp
     mv debian/tmp/usr/lib/tclConfig.sh debian/tcl$(v)-dev/usr/lib/tcl$(v)
     cp unix/tcl.m4 debian/tcl$(v)-dev/usr/share/aclocal/tcl.m4
	
this avoids ending up with an empty  usr/share/tcltk dir

Are there actually more .sh files than tclConfig.sh? I don't see any.

Is there some reason why the file needs to be in
/usr/share/tcltk/tcl8.5/ too? If so then we need to work out how to
deal with this.

I have attached the latter patch.



-- System Information:
Debian Release: 6.0
  APT prefers testing
  APT policy: (990, 'testing'), (500, 'unstable'), (1, 'experimental')
Architecture: amd64 (x86_64)

Kernel: Linux 2.6.37-trunk-amd64 (SMP w/2 CPU cores)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/bash

Versions of packages tcl8.5-dev depends on:
ii  tcl8.5                        8.5.8-2    Tcl (the Tool Command Language) v8

tcl8.5-dev recommends no packages.

Versions of packages tcl8.5-dev suggests:
pn  tcl8.5-doc                    <none>     (no description available)

-- no debconf information
Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#611650; Package tcl8.5-dev. (Mon, 31 Jan 2011 17:15:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Mon, 31 Jan 2011 17:15:12 GMT) Full text and rfc822 format available.

Message #10 received at 611650@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: 611650@bugs.debian.org
Subject: Re: Bug#611650: Acknowledgement (tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh))
Date: Mon, 31 Jan 2011 17:12:42 +0000
+++ Debian Bug Tracking System [2011-01-31 17:09 +0000]:

And here's the patch I forgot:

diff -u /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/changelog /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/changelog
--- /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/changelog	2011-01-31 15:08:56.000000000 +0000
+++ /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/changelog	2011-01-31 15:04:13.844713996 +0000
@@ -1,3 +1,10 @@
+tcl8.5 (8.5.8-2.1) unstable; urgency=low
+
+  * Non-maintainer upload.
+  * Move arch-dependent /usr/share/tcltk/tcl8.5/tclConfig.sh to /usr/lib
+
+ -- Wookey <wookey@debian.org>  Mon, 31 Jan 2011 15:03:12 +0000
+
 tcl8.5 (8.5.8-2) unstable; urgency=low
 
   * Fixed building on MIPS architectures. The upstream changes in 8.5.8
diff -u /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/rules /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/rules
--- /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/rules	2011-01-31 15:08:56.000000000 +0000
+++ /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/rules	2011-01-31 15:33:42.180713997 +0000
@@ -98,8 +98,8 @@
 	cp unix/libtcl$(v).a debian/tmp/usr/lib
 	#mv debian/tmp/usr/lib/libtcl$(v).so debian/tmp/usr/lib/libtcl$(v).so.0
 	#ln -sf libtcl$(v).so.0 debian/tmp/usr/lib/libtcl$(v).so
-	mv debian/tmp/usr/lib/*.sh debian/tmp/usr/share/tcltk/tcl$(v)
-	cp unix/tcl.m4 debian/tmp/usr/share/tcltk/tcl$(v)/tcl.m4
+	mv debian/tmp/usr/lib/*.sh debian/tcl$(v)-dev/usr/lib/tcl$(v)
+	cp unix/tcl.m4 debian/tcl$(v)-dev/usr/share/aclocal/tcl.m4
 	rm -f debian/tmp/usr/share/tcltk/tcl$(v)/ldAix
 	# Fix up the include files.
 	install -d debian/tmp/usr/include/tcl$(v)/tcl-private/generic
@@ -158,13 +158,6 @@
 	dh_testdir -a
 	dh_testroot -a
 	dh_movefiles -a
-	# now, fix up file locations for .sh and .m4
-	mv debian/tcl$(v)/usr/share/tcltk/tcl$(v)/tcl.m4 \
-	   debian/tcl$(v)-dev/usr/share/aclocal/tcl$(v).m4
-	mv debian/tcl$(v)/usr/share/tcltk/tcl$(v)/tclConfig.sh \
-	   debian/tcl$(v)-dev/usr/share/tcltk/tcl$(v)
-	ln -s ../../share/tcltk/tcl$(v)/tclConfig.sh \
-	      debian/tcl$(v)-dev/usr/lib/tcl$(v)/tclConfig.sh
 	dh_installdocs -a
 	dh_installmenu -a
 	dh_installchangelogs -a ChangeLog
diff -u /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/tcl8.5-dev.dirs /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/tcl8.5-dev.dirs
--- /home/wookey/debian/squeeze/tcl8.5-8.5.8/debian/tcl8.5-dev.dirs	2011-01-31 15:08:56.000000000 +0000
+++ /home/wookey/ubuntu/maverick/build/tcl8.5-8.5.8/debian/tcl8.5-dev.dirs	2011-01-31 16:59:19.572713996 +0000
@@ -1,3 +1,2 @@
 usr/lib/tcl8.5
 usr/share/aclocal
-usr/share/tcltk/tcl8.5

Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#611650; Package tcl8.5-dev. (Mon, 31 Jan 2011 18:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergei Golovan <sgolovan@nes.ru>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Mon, 31 Jan 2011 18:21:05 GMT) Full text and rfc822 format available.

Message #15 received at 611650@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@nes.ru>
To: Wookey <wookey@wookware.org>, 611650@bugs.debian.org
Subject: Re: [Pkg-tcltk-devel] Bug#611650: tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)
Date: Mon, 31 Jan 2011 21:16:37 +0300
On Mon, Jan 31, 2011 at 8:08 PM, Wookey <wookey@wookware.org> wrote:
>
> Line 22 of that file is TCL_CC='x86_64-linux-gnu-gcc' on the x86_64
> version and TCL_CC='arm-linux-gnueabi-gcc' on the armel version.
> Also the TCL_DEFS= varies with arch, e.g 64-bit arches have different
> defines from 32-bit arches.
> So in fact it's not an arch-independent file, and shouldn't be in
> /usr/share.

I missed the fact that these scripts are actually arch-dependent. They
should go into /usr/lib/tcltk/tcl8.5 indeed. Thanks for the finding.

>
> I notice that upstream tcl builds these files in /lib but then we move
> them into /usr/share and then put a link back in the old place. Is
> there a good reason for this, or should we just leave them in /lib in
> the first place?

Yes, though not in /usr/lib itself but in /usr/lib/tcl8.5 because there
are other Tcl/Tk versions around, and symlink /usr/lib/tclConfig.sh is
managed by tcl-dev package (points to the default version).

Cheers!
-- 
Sergei Golovan




Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#611650; Package tcl8.5-dev. (Tue, 01 Feb 2011 01:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Wookey <wookey@wookware.org>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Tue, 01 Feb 2011 01:45:07 GMT) Full text and rfc822 format available.

Message #20 received at 611650@bugs.debian.org (full text, mbox):

From: Wookey <wookey@wookware.org>
To: Sergei Golovan <sgolovan@nes.ru>
Cc: 611650@bugs.debian.org
Subject: Re: [Pkg-tcltk-devel] Bug#611650: tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)
Date: Tue, 1 Feb 2011 01:41:11 +0000
+++ Sergei Golovan [2011-01-31 21:16 +0300]:
> On Mon, Jan 31, 2011 at 8:08 PM, Wookey <wookey@wookware.org> wrote:
> >
> > Line 22 of that file is TCL_CC='x86_64-linux-gnu-gcc' on the x86_64
> > version and TCL_CC='arm-linux-gnueabi-gcc' on the armel version.
> > Also the TCL_DEFS= varies with arch, e.g 64-bit arches have different
> > defines from 32-bit arches.
> > So in fact it's not an arch-independent file, and shouldn't be in
> > /usr/share.
> 
> I missed the fact that these scripts are actually arch-dependent. They
> should go into /usr/lib/tcltk/tcl8.5 indeed. Thanks for the finding.

No problem - thanks for the quick response.

Unfortunately we'll be stuck with this problem in squeeze so anything
cross-depending on tcl8.5-dev (and using the tclConfig.sh mechanism)
won't cross-build. Still, lots of stuff in squeeze won't cross-build
so it's just one of those things. 

> > I notice that upstream tcl builds these files in /lib but then we move
> > them into /usr/share and then put a link back in the old place. Is
> > there a good reason for this, or should we just leave them in /lib in
> > the first place?
> 
> Yes, though not in /usr/lib itself but in /usr/lib/tcl8.5 because there
> are other Tcl/Tk versions around, and symlink /usr/lib/tclConfig.sh is
> managed by tcl-dev package (points to the default version).

Agreed.

Just for info there is further discusison of this issue here: 
http://lists.debian.org/debian-devel/2011/01/msg00874.html

Wookey
-- 
Principal hats:  Linaro, Emdebian, Wookware, Balloonboard, ARM
http://wookware.org/




Information forwarded to debian-bugs-dist@lists.debian.org, Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>:
Bug#611650; Package tcl8.5-dev. (Tue, 01 Feb 2011 09:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Sergei Golovan <sgolovan@nes.ru>:
Extra info received and forwarded to list. Copy sent to Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>. (Tue, 01 Feb 2011 09:51:03 GMT) Full text and rfc822 format available.

Message #25 received at 611650@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@nes.ru>
To: Wookey <wookey@wookware.org>
Cc: 611650@bugs.debian.org
Subject: Re: [Pkg-tcltk-devel] Bug#611650: tcl8.5-dev contains arch-dependent file in /usr/share/ (tcltk/tcl8.5/tclConfig.sh)
Date: Tue, 1 Feb 2011 12:48:30 +0300
[Message part 1 (text/plain, inline)]
Hi!

Could you try the attached patch? Is it enough, or there's something
else which should be changed for cross-compilation to work?

Cheers!
-- 
Sergei Golovan
[tcl8.5.diff (text/x-patch, attachment)]

Reply sent to Sergei Golovan <sgolovan@debian.org>:
You have taken responsibility. (Thu, 03 Mar 2011 17:21:03 GMT) Full text and rfc822 format available.

Notification sent to Wookey <wookey@wookware.org>:
Bug acknowledged by developer. (Thu, 03 Mar 2011 17:21:04 GMT) Full text and rfc822 format available.

Message #30 received at 611650-close@bugs.debian.org (full text, mbox):

From: Sergei Golovan <sgolovan@debian.org>
To: 611650-close@bugs.debian.org
Subject: Bug#611650: fixed in tcl8.5 8.5.9-2
Date: Thu, 03 Mar 2011 17:17:20 +0000
Source: tcl8.5
Source-Version: 8.5.9-2

We believe that the bug you reported is fixed in the latest version of
tcl8.5, which is due to be installed in the Debian FTP archive:

tcl8.5-dev_8.5.9-2_i386.deb
  to main/t/tcl8.5/tcl8.5-dev_8.5.9-2_i386.deb
tcl8.5-doc_8.5.9-2_all.deb
  to main/t/tcl8.5/tcl8.5-doc_8.5.9-2_all.deb
tcl8.5_8.5.9-2.diff.gz
  to main/t/tcl8.5/tcl8.5_8.5.9-2.diff.gz
tcl8.5_8.5.9-2.dsc
  to main/t/tcl8.5/tcl8.5_8.5.9-2.dsc
tcl8.5_8.5.9-2_i386.deb
  to main/t/tcl8.5/tcl8.5_8.5.9-2_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 611650@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Sergei Golovan <sgolovan@debian.org> (supplier of updated tcl8.5 package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Thu, 03 Mar 2011 20:01:52 +0300
Source: tcl8.5
Binary: tcl8.5 tcl8.5-doc tcl8.5-dev
Architecture: source all i386
Version: 8.5.9-2
Distribution: unstable
Urgency: low
Maintainer: Tcl/Tk Debian Packagers <pkg-tcltk-devel@lists.alioth.debian.org>
Changed-By: Sergei Golovan <sgolovan@debian.org>
Description: 
 tcl8.5     - Tcl (the Tool Command Language) v8.5 - run-time files
 tcl8.5-dev - Tcl (the Tool Command Language) v8.5 - development files
 tcl8.5-doc - Tcl (the Tool Command Language) v8.5 - manual pages
Closes: 611650
Changes: 
 tcl8.5 (8.5.9-2) unstable; urgency=low
 .
   * Moved /usr/share/tcltk/tcl8.5/tclConfig.sh back to the /usr/lib/tcl8.5
     directory because it is architecture dependent (closes: #611650).
Checksums-Sha1: 
 ae27f7f1e371f710d46674440f934aee73ef628d 1109 tcl8.5_8.5.9-2.dsc
 501e7561c9d3af41b8f66fd596fa3dc87b7c607f 11924 tcl8.5_8.5.9-2.diff.gz
 49886d86b352e293acdd58987adc582a83bb9323 1144654 tcl8.5-doc_8.5.9-2_all.deb
 09e534485626e3ab79131d6d90bfb454a2cf7fa2 1587278 tcl8.5_8.5.9-2_i386.deb
 f782545827d8bcb8bd99485cb43930caec1d7953 1022300 tcl8.5-dev_8.5.9-2_i386.deb
Checksums-Sha256: 
 b61043491e16286ec9dbdd31303d07e13e613c4839765c93bb41a45f255c28ef 1109 tcl8.5_8.5.9-2.dsc
 4555da218b13291cdb1e1cc933d0a545782cac3c7131bd6fc890fde96f55159d 11924 tcl8.5_8.5.9-2.diff.gz
 f92221ff9c819da73e9d646e365cd3984d836eb9c6afdf28b3556402f6f07d78 1144654 tcl8.5-doc_8.5.9-2_all.deb
 dd2c494c499b4c5f794558f81188e570550a4bb98fed7975d027e3ad1c229a6b 1587278 tcl8.5_8.5.9-2_i386.deb
 5ae18ee6bde61d28799a8f354bd53eb60b815dae07fa67c114f9264706bb56c0 1022300 tcl8.5-dev_8.5.9-2_i386.deb
Files: 
 69a7eeabe4f901d88db65cf4e51baf0e 1109 libs optional tcl8.5_8.5.9-2.dsc
 2ab751eeb5ed8de856f8c674dea7c0d7 11924 libs optional tcl8.5_8.5.9-2.diff.gz
 c4812b027459d3080bf1b0b5f615c7cf 1144654 doc optional tcl8.5-doc_8.5.9-2_all.deb
 44408d493bf45d7d5a7e69f2c8e74952 1587278 interpreters optional tcl8.5_8.5.9-2_i386.deb
 819e029dcd1b8447becdcda500666cd0 1022300 devel optional tcl8.5-dev_8.5.9-2_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iD8DBQFNb8qsIcdH02pGEFIRAm5DAJ91ItCSnlF0RLk5ytbvEPwlq61tqwCff5iv
zpJljoqb1QmGWI95Cbj2bYU=
=GGGr
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Thu, 07 Jul 2011 07:40:26 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 19:44:35 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.